//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TBoiler.h"
#include "TModelCoffee.h"
#include "Logging.h"
#define NoPortionsInCup 5
//
void TBoiler::Init (double MinTemp, double MaxTemp, int CupsNeeded, TCoffeeModel *NewCoffeeModel)
    {
    CoffeeModel = NewCoffeeModel;
    Clapan1.Init(0, CoffeeModel);
    Clapan2.Init(1, CoffeeModel);
    Heater1.Init(0, MinTemp, MaxTemp, CoffeeModel);
    Heater2.Init(1, 55, 75, CoffeeModel);
    PortionsNeeded = CupsNeeded * NoPortionsInCup;
    y1 = 0;
    }
// -    
bool TBoiler::BoiledAllPortions()
{
    return (PortionsBoiled >= PortionsNeeded);
}
//   
void TBoiler::IncBoiledPortions()
{
        PortionsBoiled++;
}
//   
void TBoiler::ClearBoiledPortions()
{
    PortionsBoiled = 0;
}
// 
//  1   0 ( )
void TBoiler::Go()
    {
    if (y1 == 0) return;
    A1(0);
    }
//  1   6 (  )
void TBoiler::StartBoiler() //
    {
    A1(6);
    }
//  1   7 (  /  )
void TBoiler::StopBoiler()// 
    {
    A1(7);
    }
//   1
//  "  "
bool TBoiler::is_Ready()     // -   ?
    {
    return (y1 == 0);
    }
//  " "
bool TBoiler::is_WarmingUpHeaters()    // -  ?
    {
    return (y1 == 1);
    }
//  "    "
bool TBoiler::is_ReadyForNextPortion() // -     ?
    {
    return (y1 == 2);
    }
//  " "
bool TBoiler::is_TakingWater()    // -  ?
    {
    return (y1 == 3);
    }
//  ""
bool TBoiler::is_Boiling()     // - ?
    {
    return (y1 == 4);
    }
//  " "
bool TBoiler::is_FreeingSteam()     // -  ?
    {
    return (y1 == 5);
    }
//  "  "
bool TBoiler::is_HeatingReadyCoffee()     // - ?
    {
    return (y1 == 6);
    }
//  ""
bool TBoiler::is_Error()     // - ?
    {
    return (y1 == 7);
    }
//  " "
bool TBoiler::is_NoWater()   // -  ?
    {
    return (y1 == 8);
    }
// 
//x6 -  
bool TBoiler::x6()  // 
    {
    bool result;
    AnsiString sResult;
    result = CoffeeModel->NoWater();
    sResult = (result) ? "true" : "false";
    AppendToLog(">", "x6 -   -  " + sResult );
    return result;
    }
//x7 -    
bool TBoiler::x7()  //   
    {
    bool result;
    AnsiString sResult;
    result = BoiledAllPortions();
    sResult = (result) ? "true" : "false";
    AppendToLog(">", "x7 -     -  " + sResult );
    return result;
    }

// 
//   
bool TBoiler::T5()   //    
    {
    bool result;
    AnsiString sResult;
    result = CoffeeModel->T5();
    sResult = (result) ? "true" : "false";
    AppendToLog(">", "T5 -      -  " + sResult );
    return result;
    }
//     
void TBoiler::t5()   //     
    {
    AppendToLog("*", "t4 -     ");
    CoffeeModel->t5();
    }
//     
void TBoiler::tz5()   //     
    {
    AppendToLog("*", "tz4 -     ");
    CoffeeModel->tz5();
    }

// 
//  
void TBoiler::z11_1()  //  
    {
    AppendToLog("*", "z11_1 -   ");
    Heater1.Start();
    }
//  
void TBoiler::z11_2()
    {
    AppendToLog("*", "z11_2 -   ");
    Heater2.Start();
    }
//  
void TBoiler::z12_1()
    {
    AppendToLog("*", "z12_1 -   ");
    Heater1.Stop();
    }
//  
void TBoiler::z12_2()
    {
    AppendToLog("*", "z12_2 -   ");
    Heater2.Stop();
    }
//  
void TBoiler::z13_1()  //  
    {
    AppendToLog("*", "z13_1 -   ");
    Clapan1.Open();
    }
//  
void TBoiler::z13_2()  //  
    {
    AppendToLog("*", "z13_2 -   ");
    Clapan2.Open();
    }
//   
void TBoiler::z14()    //   
    {
    AppendToLog("*", "z14 -    ");
    IncBoiledPortions();
    }
//   
void TBoiler::z15()    //   
    {
    AppendToLog("*", "z15 -    ");
    ClearBoiledPortions();
    }
//   
void TBoiler::z16()    //   
    {
    AppendToLog("*", "z16 -    ");
    CoffeeModel->SetDisplay2(" ");
    }
//   
void TBoiler::z17()    //   
    {
    AppendToLog("*", "z17 -    ");
    CoffeeModel->SetDisplay2("");
    }
//  
void TBoiler::z31()    //  
    {
    AppendToLog("*", "z17 -    ");
    CoffeeModel->SetDisplay2(": " + IntToStr(PortionsBoiled / NoPortionsInCup) + "/" + IntToStr(PortionsNeeded/ NoPortionsInCup));
    }
// 
void TBoiler::z32()    // 
    {
    AppendToLog("*", "z17 -   ");
    CoffeeModel->SetDisplay2(" .");
    }
//   1
void TBoiler::z33_1()    //  
    {
    AppendToLog("*", "z33 -   1");
    Clapan1.Reset();
    }
//   2
void TBoiler::z33_2()    //  
    {
    AppendToLog("*", "z33 -   1");
    Clapan2.Reset();
    }
//   1
void TBoiler::z34_1()    //  1
    {
    AppendToLog("*", "z34 -   1");
    Heater1.Reset();
    }
//   2
void TBoiler::z34_2()    //  1
    {
    AppendToLog("*", "z34 -   1");
    Heater2.Reset();
    }

//  1
void TBoiler::A1(int e)
{
    int old_y1;
    AnsiString StateDescr;
    AnsiString NewStateDescr;
    AnsiString EventDescr;
    bool bx6;
    bool bx7;
    bool bT5;

    old_y1 = y1;
    //  
    switch (y1)
        {
        case 0:
            StateDescr = " (\"  \")";
        break;
        case 1:
            StateDescr = " (\" \")";
        break;
        case 2:
            StateDescr = " (\"    \")";
        break;
        case 3:
            StateDescr = " (\" \")";
        break;
        case 4:
            StateDescr = " (\"\")";
        break;
        case 5:
            StateDescr = " (\" \")";
        break;
        case 6:
            StateDescr = " (\"  \")";
        break;
        case 7:
            StateDescr = " (\"\")";
        break;
        case 8:
            StateDescr = " (\" \")";
        break;
        default:
            StateDescr = " !!!     !!!";
        break;
        }
    switch (e)
        {
        case 0:
            EventDescr = " (\"  \")";
        break;
        case 6:
            EventDescr = " (\"  \")";
        break;
        case 7:
            EventDescr = " (\"  /  \")";
        break;
        default:
            EventDescr = " !!!     !!!";
        break;
        }
    AppendToLog("{", "A1:   " + IntToStr(y1) + StateDescr + "    e" + IntToStr(e) + EventDescr);

    bx6 = x6();  // 
    bx7 = x7();  //   
    bT5 = T5();  //    

    switch (y1)
    {
        case 0:
            if (e == 6)   {z11_1();z11_2();z15();z32();         y1 = 1; }
        break;

        case 1:
            if (e == 7)   {z12_1();z12_2();                     y1 = 0;}
            if ((Heater1.is_On()||Heater1.is_Off())&&
                    (Heater2.is_On()||Heater2.is_Off()))        y1 = 2;

            if (Heater1.is_Error()||Heater2.is_Error())
                    {z12_1();z12_2();                           y1 = 7;}
        break;

        case 2:
            if (e == 7)   {z12_1();z12_2();                     y1 = 0;}
            if (Clapan1.is_Error()||Clapan2.is_Error()){        y1 = 7;}
            else
            if (bx6)   {z16();z12_1();                          y1 = 8;}
            else
            if (bx7)   {z12_1();                                y1 = 6;}
            else
                {z13_1();z31();                                 y1 = 3;}
        break;

        case 3:
            if (e == 7)   {z12_1();z12_2();                     y1 = 0;}
            else
            if (Clapan1.is_Error()) {                           y1 = 2;}
            else
            if (Clapan1.is_Ready()) { t5();                     y1 = 4;}
        break;

        case 4:
            if (e == 7)   {tz5();z12_1();z12_2();               y1 = 0;}
            else
            if (bT5) { tz5();z13_2();                           y1 = 5;}
        break;

        case 5:
            if (e == 7)   {z12_1();z12_2();                     y1 = 0;}
            else
            if (Clapan2.is_Ready()||Clapan2.is_Error()){z14();  y1 = 2;}
        break;

        case 6:
            if (e == 7)   {z12_2();                             y1 = 0;}
        break;

        case 7:
            if (e == 7)   {z33_1();z33_2();z34_1();z34_2();     y1 = 0;}
        break;

        case 8:
            if (e == 7)   {z12_1();z12_2();                     y1 = 0;}
            if (!bx6)   {z17();z11_1();                         y1 = 1;}
        break;
    }


    //"" 
    switch (y1)
    {
        case 0:
        break;

        case 1:
            Heater1.Go(); Heater2.Go();
        break;

        case 2:
            Heater1.Go(); Heater2.Go();
        break;

        case 3:
            Heater1.Go(); Heater2.Go(); Clapan1.Go();
        break;

        case 4:
            Heater1.Go(); Heater2.Go();
        break;

        case 5:
            Heater1.Go(); Heater2.Go(); Clapan2.Go();
        break;

        case 6:
            Heater2.Go();
        break;

        case 7:
        break;

        case 8:
            Heater2.Go();
        break;
    }


    switch (y1)
        {
        case 0:
            NewStateDescr = " (\"  \")";
        break;
        case 1:
            NewStateDescr = " (\" \")";
        break;
        case 2:
            NewStateDescr = " (\"    \")";
        break;
        case 3:
            NewStateDescr = " (\" \")";
        break;
        case 4:
            NewStateDescr = " (\"\")";
        break;
        case 5:
            NewStateDescr = " (\" \")";
        break;
        case 6:
            NewStateDescr = " (\"  \")";
        break;
        case 7:
            NewStateDescr = " (\"\")";
        break;
        case 8:
            NewStateDescr = " (\" \")";
        break;
        default:
            StateDescr = " !!!     !!!";
        break;
        }

    if (y1 != old_y1)
        {
        AppendToLog("T", "A1:    " + IntToStr(old_y1) + StateDescr + "   " + IntToStr(y1) + NewStateDescr);
        }
    AppendToLog("}", "A1:    e" + IntToStr(e) + EventDescr + "   " + IntToStr(y1) + NewStateDescr);
}
//---------------------------------------------------------------------------
#pragma package(smart_init)
