//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TCoffeeControl.h"
#include "Logging.h"
//
void TCoffeeControl::Init(TCoffeeModel *NewCoffeeModel)
{
    CoffeeModel = NewCoffeeModel;
    Temperature = 100;
    NeededCups = 5;
    Boiler.Init(Temperature - 5, Temperature + 5, NeededCups, CoffeeModel);
    y0 = 0;
}
// 
//  0   0 ( )
void TCoffeeControl::Go()
{
    if (y0 == 0) return;
    A0(0);
}
//  0   8 ( +)
void TCoffeeControl::PressPlus()
{
    A0(8);
}
//  0   9 ( -)
void TCoffeeControl::PressMinus()
{
    A0(9);
}
//  0   10 ( OK)
void TCoffeeControl::PressOk()
{
    A0(10);
}
//  0   11 ( CANCEL)
void TCoffeeControl::PressCancel()
{
    A0(11);
}

//  "  "
bool TCoffeeControl::is_Ready()
{
    return y0 == 0;
}

//  " "
bool TCoffeeControl::is_ChooseTemp()
{
    return y0 == 1;
}
//  "  "
bool TCoffeeControl::is_ChooseQty()
{
    return y0 == 2;
}
//  " "
bool TCoffeeControl::is_Boiling()
{
    return y0 == 3;
}
//  " "
bool TCoffeeControl::is_CoffeReady()
{
    return y0 == 4;
}
//  " "
bool TCoffeeControl::is_InterrupedByUser()
{
    return y0 == 5;
}
//  ""
bool TCoffeeControl::is_Error()
{
    return y0 == 6;
}

// 
//  
void TCoffeeControl::z18()
    {
    AppendToLog("*", "z18 -   ");
    if (Temperature < 150 ) Temperature += 5;
    Boiler.Init(Temperature - 5, Temperature + 5, NeededCups, CoffeeModel);
    }
//  
void TCoffeeControl::z19()
    {
    AppendToLog("*", "z19 -   ");
    if (Temperature > 50 ) Temperature -= 5;
    Boiler.Init(Temperature - 5, Temperature + 5, NeededCups, CoffeeModel);
    }
//  
void TCoffeeControl::z20()
    {
    AppendToLog("*", "z20 -   ");
    if (NeededCups < 25  ) NeededCups++;
    Boiler.Init(Temperature - 5, Temperature + 5, NeededCups, CoffeeModel);
    }
//  
void TCoffeeControl::z21()
    {
    AppendToLog("*", "z21 -   ");
    if (NeededCups > 1  ) NeededCups--;
    Boiler.Init(Temperature - 5, Temperature + 5, NeededCups, CoffeeModel);
    }
// 
void TCoffeeControl::z22()
    {
    AppendToLog("*", "z22 -  ");
    Boiler.StartBoiler();
    }
// 
void TCoffeeControl::z23()
    {
    AppendToLog("*", "z23 -  ");
    Boiler.StopBoiler();
    }
// 
void TCoffeeControl::z24()
    {
    AppendToLog("*", "z24 -  ");
    CoffeeModel->SetDisplay1("");
    CoffeeModel->SetDisplay2("");
    }
//   
void TCoffeeControl::z25()
    {
    AppendToLog("*", "z25 -    ");
    CoffeeModel->SetDisplay1("");
    CoffeeModel->SetDisplay2(IntToStr(Temperature));
    }
//    
void TCoffeeControl::z26()
    {
    AppendToLog("*", "z26 -     ");
    CoffeeModel->SetDisplay1("");
    CoffeeModel->SetDisplay2(IntToStr(NeededCups));
    }
//  
void TCoffeeControl::z27()
    {
    AppendToLog("*", "z26 -   ");
    CoffeeModel->SetDisplay1(" ");
    CoffeeModel->SetDisplay2("");
    }
//   
void TCoffeeControl::z28()
    {
    AppendToLog("*", "z26 -    ");
    CoffeeModel->SetDisplay1("");
    CoffeeModel->SetDisplay2("");
    }
//   
void TCoffeeControl::z29()
    {
    AppendToLog("*", "z29 -    ");
    CoffeeModel->SetDisplay1(" !");
    CoffeeModel->SetDisplay2("");
    }
//  
void TCoffeeControl::z30()
    {
    AppendToLog("*", "z26 -   ");
    CoffeeModel->SetDisplay1("");
    }
// 
void TCoffeeControl::A0(int e)
 {
    int old_y0;
    AnsiString StateDescr;
    AnsiString NewStateDescr;
    AnsiString EventDescr;
    old_y0 = y0;

    //  

    switch (y0)
        {
        case 0:
            StateDescr = " (\"  \")";
        break;
        case 1:
            StateDescr = " (\" \")";
        break;
        case 2:
            StateDescr = " (\"  \")";
        break;
        case 3:
            StateDescr = " (\" \")";
        break;
        case 4:
            StateDescr = " (\" \")";
        break;
        case 5:
            StateDescr = " (\" \")";
        break;
        case 6:
            StateDescr = " (\"\")";
        break;
        default:
            StateDescr = " !!!     !!!";
        break;
        }
    switch (e)
        {
        case 0:
            EventDescr = " (\"  \")";
        break;
        case 8:
            EventDescr = " (\" '+'\")";
        break;
        case 9:
            EventDescr = " (\" '-'\")";
        break;
        case 10:
            EventDescr = " (\" 'OK'\")";
        break;
        case 11:
            EventDescr = " (\" 'CANCEL'\")";
        break;
        default:
            EventDescr = " !!!     !!!";
        break;
        }
    AppendToLog("{", "A0:   " + IntToStr(y0) + StateDescr + "    e" + IntToStr(e) + EventDescr);

    switch (y0)
    {
        case 0:
            if (e == 10)   {z25();                               y0 = 1; }
        break;

        case 1:
            if (e == 10)   {z26();                               y0 = 2; }
            else
            if (e == 11)   {z24();                               y0 = 0; }
            else
            if (e == 8)    {z18();z25();                         y0 = 1; }
            else
            if (e == 9)    {z19();z25();                         y0 = 1; }
        break;

        case 2:
            if (e == 10)   {z27();z22();                         y0 = 3; }
            else
            if (e == 11)   {z25();                               y0 = 1; }
            else
            if (e == 8)    {z20();z26();                         y0 = 2; }
            else
            if (e == 9)    {z21();z26();                         y0 = 2; }
        break;

        case 3:
            if (Boiler.is_HeatingReadyCoffee())   {z29();        y0 = 4; }
            else
            if (Boiler.is_Error()) {z30();                       y0 = 6; }
            else
            if (e == 11)    {z28();z23();                        y0 = 5; }
        break;


        case 4:
            if ((e == 11)||(e==10))  {z24();z23();               y0 = 0; }
        break;

        case 5:
            if (e == 11)  {z24();                                y0 = 0; }
        break;

        case 6:
            if (e == 11)  {z24(); z23();                         y0 = 0; }
        break;

    }

    // 
    switch (y0)
    {
        case 0:
        break;
        case 1:
        break;
        case 2:
        break;

        case 3:
            Boiler.Go();
        break;

        case 4:
            Boiler.Go();
        break;
        case 5:
        break;
        case 6:
        break;
    }
    //  
    switch (y0)
        {
        case 0:
            NewStateDescr = " (\"  \")";
        break;
        case 1:
            NewStateDescr = " (\" \")";
        break;
        case 2:
            NewStateDescr = " (\"  \")";
        break;
        case 3:
            NewStateDescr = " (\" \")";
        break;
        case 4:
            NewStateDescr = " (\" \")";
        break;
        case 5:
            NewStateDescr = " (\" \")";
        break;
        case 6:
            NewStateDescr = " (\"\")";
        break;
        default:
            StateDescr = " !!!     !!!";
        break;
        }

    if (y0 != old_y0)
        {
        AppendToLog("T", "A0:    " + IntToStr(old_y0) + StateDescr + "   " + IntToStr(y0) + NewStateDescr);
        }
    AppendToLog("}", "A0:    e" + IntToStr(e) + EventDescr + "   " + IntToStr(y0) + NewStateDescr);

}
//---------------------------------------------------------------------------
#pragma package(smart_init)
