//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "THeater.h"
#include "Logging.h"
//#include "TCoffee.h"
//---------------------------------------------------------------------------
//
void THeater::Init(int HeaterNo, double MinTemp, double MaxTemp, TCoffeeModel *NewCoffeeModel)
{
    CoffeeModel = NewCoffeeModel;
    y2 = 0;
    HeaterID = HeaterNo;
    MinTemperature = MinTemp;
    MaxTemperature = MaxTemp;
}
// 
//  2   0 (  )
void THeater::Go()
{
    if (y2 == 0) return;
    A2(0);
}
//  2   3 ( )
void THeater::Start() //
{
    A2(3);
}
//  2   4 ( )
void THeater::Stop()//
{
    A2(4);
}
//  2   5 (  )
void THeater::Reset()
{
    A2(5);
}
//   2
//  "  "
bool THeater::is_Ready()
{
    return (y2 == 0);
}
//  ""
bool THeater::is_WarmingUp()
{
    return (y2 == 1);
}
//  ""
bool THeater::is_On()
{
    return (y2 == 2);
}
//  ""
bool THeater::is_Off()
{
    return (y2 == 3);
}
//  ""
bool THeater::is_Error()
{
    return (y2 == 4);
}

// 
//   
bool THeater::x3()
{
    bool result;
    AnsiString sResult;
    result = (CoffeeModel->HeaterTemp(HeaterID) <= MinTemperature);
    sResult = (result) ? "true" : "false";
    AppendToLog(">", "x3 -  " + IntToStr(HeaterID+1) + "    -  " + sResult );
    return result;
}
//   
bool THeater::x4()
{
    bool result;
    AnsiString sResult;
    result = (CoffeeModel->HeaterTemp(HeaterID) >= MaxTemperature);
    sResult = (result) ? "true" : "false";
    AppendToLog(">", "x4 -  " + IntToStr(HeaterID+1) + "    -  " + sResult );
    return result;
}
//    ( )
bool THeater::x5()
{
    bool result;
    AnsiString sResult;
    result = (CoffeeModel->HeaterTemp(HeaterID) > MinTemperature);
    sResult = (result) ? "true" : "false";
    AppendToLog(">", "x5 -  " + IntToStr(HeaterID+1) + "    -  " + sResult );
    return result;
}
// 
//  " "
void THeater::z7()
{
    AppendToLog("*", "z1 -   " + IntToStr(HeaterID+1));
    CoffeeModel->Heater_On(HeaterID, true);
}
//  " "
void THeater::z8()
{
    AppendToLog("*", "z1 -   " + IntToStr(HeaterID+1));
    CoffeeModel->Heater_On(HeaterID, false);
    return;
}
//  " "
void THeater::z9()
{
    AppendToLog("*", "z1 -    " + IntToStr(HeaterID+1));
    CoffeeModel->SetDisplay2(".  " + IntToStr(HeaterID+1));
}
//  " "
void THeater::z10()
{
    AppendToLog("*", "z1 -    " + IntToStr(HeaterID+1));
    CoffeeModel->SetDisplay2("");
}
// 
//     
void THeater::t4()
{
    AppendToLog("*", "t4 -      " + IntToStr(HeaterID+1));
    CoffeeModel->t4(HeaterID);
}
//     
void THeater::tz4()
{
    AppendToLog("*", "tz4 -      " + IntToStr(HeaterID+1));
    CoffeeModel->tz4(HeaterID);
}
//   
bool THeater::T4()
{
    bool result;
    AnsiString sResult;
    result = CoffeeModel->T4(HeaterID);
    sResult = (result) ? "true" : "false";
    AppendToLog(">", "T4 -     " + IntToStr(HeaterID+1) + "  -  " + sResult );
    return result;
}
//  2
void THeater::A2(int e)
{
    int old_y2;
    AnsiString StateDescr;
    AnsiString NewStateDescr;
    AnsiString EventDescr;
    bool bx3;
    bool bx4;
    bool bx5;
    bool bT4;

    old_y2 = y2;
    //  
    switch (y2)
        {
        case 0:
            StateDescr = " (\"  \")";
        break;
        case 1:
            StateDescr = " (\"\")";
        break;
        case 2:
            StateDescr = " (\"\")";
        break;
        case 3:
            StateDescr = " (\"\")";
        break;
        case 4:
            StateDescr = " (\"\")";
        break;
        default:
            StateDescr = " !!!     !!!";
        break;
        }
    switch (e)
        {
        case 0:
            EventDescr = " (\"  \")";
        break;
        case 3:
            EventDescr = " (\" \")";
        break;
        case 4:
            EventDescr = " (\" \")";
        break;
        case 5:
            EventDescr = " (\"  \")";
        break;
        default:
            EventDescr = " !!!     !!!";
        break;
        }
    AppendToLog("{", "A2_"+ IntToStr(HeaterID+1)+":   " + IntToStr(y2) + StateDescr + "    e" + IntToStr(e) + EventDescr);

    bx3 = x3();
    bx4 = x4();
    bx5 = x5();
    bT4 = T4();
    switch (y2)
    {
        case 0:
            if (e == 3)         {z7();t4();         y2 = 1; };
        break;

        case 1:
            if (e == 4)      {tz4();z8();           y2 = 0;}
            else
            if (bx5)         {tz4();                y2 = 2;}
            else
            if (!bx5 & bT4)  {tz4();z9();z8();      y2 = 4;};
        break;

        case 2:
            if (e == 4)         {z8();              y2 = 0;}
            else
            if (bx4)           {z8();               y2 = 3;};
        break;

        case 3:
            if (e == 4)         {                   y2 = 0;}
            else
            if (bx3)           {z7();               y2 = 2;};
        break;

        case 4:
            if (e == 5)         {z10();             y2 = 0;};
        break;
    }
    switch (y2)
        {
        case 4:
            z8();
        break;
        }

    //  
    switch (y2)
        {
        case 0:
            NewStateDescr = " (\"  \")";
        break;
        case 1:
            NewStateDescr = " (\"\")";
        break;
        case 2:
            NewStateDescr = " (\"\")";
        break;
        case 3:
            NewStateDescr = " (\"\")";
        break;
        case 4:
            NewStateDescr = " (\"\")";
        break;
        default:
            StateDescr = " !!!     !!!";
        break;
        }
    if (y2 != old_y2)
        {
        AppendToLog("T", "A2_"+ IntToStr(HeaterID+1)+":    " + IntToStr(old_y2) + StateDescr + "   " + IntToStr(y2) + NewStateDescr);
        }
    AppendToLog("}", "A2_"+ IntToStr(HeaterID+1)+":    e" + IntToStr(e) + EventDescr + "   " + IntToStr(y2) + NewStateDescr);
}
//---------------------------------------------------------------------------
#pragma package(smart_init)
