//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TModelCoffee.h"
#include "UMain.h"
extern TCoffeeBoiler *CoffeeBoiler;

//
void TCoffeeModel::Init()
{
    Heater_MAXTemp[0] = 110;
    Heater_MINTemp[0] = 95;
    Heater_MAXTemp[1] = 60;
    Heater_MINTemp[1] = 50;

    Heater_HeatSpeed[0] = 2;
    Heater_CoolSpeed[0] = 0.1;
    Heater_HeatSpeed[1] = 2;
    Heater_CoolSpeed[1] = 0.1;

    Clapan_MAX[0] = 5;
    Clapan_MAX[1] = 5;
    Clapan_Speed[0] = 1;
    Clapan_Speed[1] = 1;

    Clapan[0] = 0;
    bClapan_OpenSignal[0] = false;
    bClapan_CloseSignal[0] = false;
    Clapan[1] = 0;
    bClapan_OpenSignal[1] = false;
    bClapan_CloseSignal[1] = false;

    Heater[0] = 0;
    bHeater_On[0] = false;
    Heater[1] = 0;
    bHeater_On[1] = false;

    bNoWater = false;

    t1Max[0] = 10;
    t2Max[0] = 20;
    t3Max[0] = 10;

    t1Max[1] = 10;
    t2Max[1] = 5;
    t3Max[1] = 10;
    t4Max[0] = 500;
    t4Max[1] = 500;
    t5Max = 20;
}
// 
void TCoffeeModel::GO()
{
    int i;
    for (i = 0; i < 2; i++)
    {
        if (bClapan_OpenSignal[i])
        {
            Clapan[i] += Clapan_Speed[i];
            if (Clapan[i] > Clapan_MAX[i]) Clapan[i] = Clapan_MAX[i];
        };

        if (bClapan_CloseSignal[i])
        {
            Clapan[i] -= Clapan_Speed[i];
            if (Clapan[i] < 0) Clapan[i] = 0;
        };
    }
    for (i = 0; i < 2; i++)
    {
        if (bHeater_On[i])
        {
            Heater[i] += Heater_HeatSpeed[i];
        }
        else
        {
            Heater[i] -= Heater_CoolSpeed[i];
            if (Heater[i] < 0) Heater[i] = 0;
        }
    }
    if ((t1Passed[0] > 0) && (t1Passed[0] < t1Max[0])) t1Passed[0]++;
    if ((t2Passed[0] > 0) && (t2Passed[0] < t2Max[0])) t2Passed[0]++;
    if ((t3Passed[0] > 0) && (t3Passed[0] < t3Max[0])) t3Passed[0]++;

    if ((t1Passed[1] > 0)&&(t1Passed[1] < t1Max[1])) t1Passed[1]++;
    if ((t2Passed[1] > 0)&&(t2Passed[1] < t2Max[1])) t2Passed[1]++;
    if ((t3Passed[1] > 0)&&(t3Passed[1] < t3Max[1])) t3Passed[1]++;

    if ((t4Passed[0] > 0)&& (t4Passed[0] < t4Max[0])) t4Passed[0]++;
    if ((t4Passed[1] > 0)&& (t4Passed[1] < t4Max[1])) t4Passed[1]++;

    if ((t5Passed > 0)&&(t5Passed < t5Max)) t5Passed++;
}

// 
//   
void TCoffeeModel::Clapan_SetOpen(int ClapanNo, bool bOpen)
{
    bClapan_OpenSignal[ClapanNo] = bOpen;
}
//   
void TCoffeeModel::Clapan_SetClose(int ClapanNo, bool bClose)
{
    bClapan_CloseSignal[ClapanNo] = bClose;
}
//  
void TCoffeeModel::Heater_On(int HeaterNo, bool bOn)
{
    bHeater_On[HeaterNo] = bOn;
}
//   
void TCoffeeModel::SetDisplay1(AnsiString str)
    {
    CoffeeBoiler->LabelDisplay1->Caption = str;
    }
//   
void TCoffeeModel::SetDisplay2(AnsiString str)
    {
    CoffeeBoiler->LabelDisplay2->Caption = str;
    }
//
// 
bool TCoffeeModel::NoWater()
{
    return bNoWater;
}
// 
bool TCoffeeModel::Clapan_isOpen(int ClapanNo)
{
    return Clapan[ClapanNo] == Clapan_MAX[ClapanNo];
}
// 
bool TCoffeeModel::Clapan_isClosed(int ClapanNo)
{
    return Clapan[ClapanNo] == 0;
}
// 
double TCoffeeModel::HeaterTemp(int HeaterNo)
{
    return Heater[HeaterNo];
}


// 
//    
void TCoffeeModel::t1(int ClapanNo)
{
    t1Passed[ClapanNo] = 1;
}
//       
void TCoffeeModel::t2(int ClapanNo)
{
    t2Passed[ClapanNo] = 1;
}
//    
void TCoffeeModel::t3(int ClapanNo)
{
    t3Passed[ClapanNo] = 1;
}
//    
void TCoffeeModel::t4(int HeaterNo)
{
    t4Passed[HeaterNo] = 1;
}
//   
void TCoffeeModel::t5()
{
    t5Passed = 1;
}

//    
void TCoffeeModel::tz1(int ClapanNo)
{
    t1Passed[ClapanNo] = 0;
}
//       
void TCoffeeModel::tz2(int ClapanNo)
{
    t2Passed[ClapanNo] = 0;
}
//    
void TCoffeeModel::tz3(int ClapanNo)
{
    t3Passed[ClapanNo] = 0;
}
//    
void TCoffeeModel::tz4(int HeaterNo)
{
    t4Passed[HeaterNo] = 0;
}
//   
void TCoffeeModel::tz5()
{
    t5Passed = 0;
}
//    
bool TCoffeeModel::T1(int ClapanNo)
{
    return t1Passed[ClapanNo] >= t1Max[ClapanNo];
}
//       
bool TCoffeeModel::T2(int ClapanNo)
{
    return t2Passed[ClapanNo] >= t2Max[ClapanNo];
}
//    
bool TCoffeeModel::T3(int ClapanNo)
{
    return t3Passed[ClapanNo] >= t3Max[ClapanNo];
}
//    
bool TCoffeeModel::T4(int HeaterNo)
{
    return t4Passed[HeaterNo] >= t4Max[HeaterNo];
}
//   
bool TCoffeeModel::T5()
{
    return t5Passed >= t5Max;
}
//---------------------------------------------------------------------------
#pragma package(smart_init)
